gr::funcube::fcd Class Referenceabstract

Funcube Dongle source block. More...

`#include <fcd.h>`

Inheritance diagram for gr::funcube::fcd:

## Public Types

typedef std::shared_ptr< fcd > | sptr

## Public Member Functions

virtual void | set_freq (float freq)=0
| Set frequency with Hz resolution. More...
virtual void | set_lna_gain (float gain)=0
| Set LNA gain. More...
virtual void | set_mixer_gain (float gain)=0
| Set mixer gain. More...
virtual void | set_freq_corr (int ppm)=0
| Set new frequency correction. More...
virtual void | set_dc_corr (double _dci, double _dcq)=0
| Set DC offset correction. More...
virtual void | set_iq_corr (double _gain, double _phase)=0
| Set IQ phase and gain balance. More...

## Static Public Member Functions

static sptr | make (const std::string device_name="")
| Return a shared_ptr to a new instance of funcube::fcd. More...

## Detailed Description

Funcube Dongle source block.

This class provides a Funcube Dongle source block by wrapping the USB audio interface and the USB HID control interface of the Funcube Dongle into one convenient source block.

The Funcube Dongle needs to have firmware 18f or later for the control interface to work properly. As of early 2011, FCDs still come with firmware 18b. You can use qthid 2.2 (not 3) to upgrade the firmware: http://qthid.sf.net

## Member Typedef Documentation

## sptr

typedef std::shared_ptr<fcd> gr::funcube::fcd::sptr

## Member Function Documentation

## make()

static sptr gr::funcube::fcd::make | ( | const std::string | device_name = `""` | ) |

static

Return a shared_ptr to a new instance of funcube::fcd.

To avoid accidental use of raw pointers, funcube::fcd's constructor is in a private implementation class. funcube::fcd::make is the public interface for creating new instances.

## set_dc_corr()

virtual void gr::funcube::fcd::set_dc_corr | ( | double | _dci,
|  | double | _dcq
| ) |  |

pure virtual

Set DC offset correction.

Parameters

  _dci | DC correction for I component (-1.0 to 1.0)
  _dcq | DC correction for Q component (-1.0 to 1.0)

Set DC offset correction in the device. Default is 0.0.

Implemented in gr::funcube::fcd_impl.

## set_freq()

virtual void gr::funcube::fcd::set_freq | ( | float | freq | ) |

pure virtual

Set frequency with Hz resolution.

Parameters

  freq | The frequency in Hz

This is a convenience function that uses float parameter in order to allow using engineering notation in GRC.

Implemented in gr::funcube::fcd_impl.

## set_freq_corr()

virtual void gr::funcube::fcd::set_freq_corr | ( | int | ppm | ) |

pure virtual

Set new frequency correction.

Parameters

  ppm | The new frequency correction in parts per million

Version 1.1 FCDs (S/N 810 or later) need a correction of -12 ppm. Earlier FCDs need roughly -120 ppm (default for gr-fcd).

Ref: http://www.funcubedongle.com/?p=617

Implemented in gr::funcube::fcd_impl.

## set_iq_corr()

virtual void gr::funcube::fcd::set_iq_corr | ( | double | _gain,
|  | double | _phase
| ) |  |

pure virtual

Set IQ phase and gain balance.

Parameters

  _gain | The gain correction (-1.0 to 1.0)
  _phase | The phase correction (-1.0 to 1.0)

Set IQ phase and gain balance in the device. The default values are 0.0 for phase and 1.0 for gain.

Implemented in gr::funcube::fcd_impl.

## set_lna_gain()

virtual void gr::funcube::fcd::set_lna_gain | ( | float | gain | ) |

pure virtual

Set LNA gain.

Parameters

  gain | The new gain in dB.

Set the LNA gain in the FCD. Valid range is -5 to

1. Although the LNA gain in the FCD takes enumerated values corresponding to 2.5 dB steps, you can can call this method with any float value and it will be rounded to the nearest valid value.

By default the LNA gain is set to 20 dB and this is a good value for most cases. In noisy areas you may try to reduce the gain.

Implemented in gr::funcube::fcd_impl.

## set_mixer_gain()

virtual void gr::funcube::fcd::set_mixer_gain | ( | float | gain | ) |

pure virtual

Set mixer gain.

Parameters

  gain | The new gain in dB.

Set the mixer gain in the FCD. Valid values are +4 and +12 dB.

By default the mixer gain is set to +12 dB and this is a good value for most cases. In noisy areas you may try to reduce the gain.

Implemented in gr::funcube::fcd_impl.

The documentation for this class was generated from the following file:

- fcd.h